Unit Stars11;

Interface

uses VGA;

Const
  Max_Stars       = 10000;

Type
  TStar = Record
    X,Y      : Word;
    Color    : Byte;
    Velocity : Byte;
  end;

  PStar = ^TStar;

Var
  Stars_Array : Array[0..Max_Stars - 1] of PStar;
  Num_Stars   : Word;

procedure Stars_Init(N:Word);
procedure Stars_Draw;
procedure Stars_Move;
procedure Stars_Done;

Implementation

procedure Stars_Init(N:Word);
var Index : Word;
  begin
    if N > MAX_STARS then N := MAX_STARS;
    if MemAvail < (Num_Stars-1) * SizeOf(TStar) then
    VGA_Fatal_Error('Not enough memory for stars');
    Num_Stars := N;
    For Index := 0 to Num_Stars - 1 do
      begin
        New(Stars_Array[Index]);
        With Stars_Array[Index]^ do
          begin
            X     := Random(320);
            Y     := Random(200);
            Color := 10 + Random(20);
            Velocity := 1 + Random(2);
          end;
        end;
      end;

procedure Stars_Draw;
var Index : Word;
  begin
    For Index := 0 to Num_Stars - 1 do
    With Stars_Array[Index]^ do
    VGA_Put_Pixel(X,Y,Color);
  end;

procedure Stars_Move;
var Index : Word;
  begin
    For Index := 0 to Num_Stars - 1 do
    With Stars_Array[Index]^ do
    if X > Velocity then Dec(X,Velocity) else
      begin
        X := 319;
        Y := Random(200);
      end;
  end;

procedure Stars_Done;
var Index : Word;
  begin
    For Index := 0 to Num_Stars - 1 do
    if Stars_Array[Index] <> nil then
    Dispose(Stars_Array[Index]);
  end;

end.




