{
 VGA.PAS ķ
 VGA 13h Library                               
 (C) The Inquisitor & The Cat                  
ͼ
}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Unit VGA;

Interface

type
  VGA_Buffer     = Array[0..320*200-1]of Byte; {᪨ }
  VGA_Buffer_Ptr = ^VGA_Buffer;
  VGA_RGB_Color  = Record                      { }
    Red,
    Green,
    Blue   : Byte;
  end;
  VGA_Palette = Array[0..255]of VGA_RGB_Color; {256-梥⭠ }

const
  Video_Buffer_Ptr : Pointer = Ptr($A000,$000);{⥫   VGA}
  VGA_256_Color  = $13;                        { 13h 256 梥⮢, 230x200}
  VGA_Text_Mode = $3;                          { CO80, ⥪⮢ 80x25x16}
  Global_Color : Byte = 1;                     {騩 梥}
  VGA_Buffer_Size = SizeOf(VGA_Buffer);

var
  Video_Buffer     : VGA_Buffer absolute $A000:$0000;
  { VGA}

  Double_Buffer    : VGA_Buffer_Ptr;

  VGA_Pal : ^VGA_Palette;

procedure VGA_Set_Mode(Mode:Byte);
procedure VGA_Put_Pixel(X,Y:Integer;Color:Byte);
procedure VGA_Direct_Put_Pixel(X,Y:Integer;Color:Byte);
function  VGA_Get_Pixel(X,Y:Word):Byte;
procedure VGA_Set_Palette(Palette:VGA_Palette);
procedure VGA_Load_Palette(Filename:String;var P:VGA_Palette;SetItNow:Boolean);
procedure VGA_Write_Palette(Filename:String;var P:VGA_Palette);
procedure VGA_Init;
procedure VGA_Done;
procedure VGA_Show_Double_Buffer;
procedure VGA_Bar(X1,Y1,X2,Y2:Integer;B:Byte);
procedure VGA_Blit_Char(XC, YC:Word; Ch:Char);
procedure VGA_Blit_String(SX,SY:Word;S:String);
procedure VGA_Blit_Char_D(XC, YC:Word; Ch:Char);
procedure VGA_Blit_String_D(SX,SY:Word;S:String);
procedure VGA_Blit_Char_2(XC, YC:Word; Ch:Char);
procedure VGA_Blit_String_2(SX,SY:Word;S:String);
procedure VGA_Set_Color(C:Byte);
procedure VGA_HLine(X1,X2,Y1 : Word);
procedure VGA_VLine(Y1,Y2,X1 : Word);
procedure VGA_Rectangle(X1,Y1,X2,Y2:Word);
procedure VGA_Blit_Cool_String(SX,SY:Word;S:String;Color:Byte);
procedure VGA_Clear_Screen;
procedure VGA_Fatal_Error(S:String);
procedure VGA_Wait_For_VSync;
procedure VGA_Make_All_BlackWhite;
procedure VGA_Line(X1,Y1,X2,Y2:Integer);
procedure VGA_Blit_Compact_String(SX,SY:Word;S:String);
procedure VGA_Make_BW;
procedure VGA_Show_Double_Buffer_2;
procedure VGA_Blit_Int(X, Y : Word; N : LongInt);
function Graph_ReadLn(S0 : String; X,Y:Word) : String;
function FileFound(S:String) : ByteBool;

Implementation

Uses LogFile, CRT, DOS;

procedure VGA_Fatal_Error(S:String);
  begin
    VGA_Done;
    LOG_WriteLn(S);
    WriteLn(S);
    Halt;
  end;

procedure VGA_Set_Mode(Mode:Byte);assembler;
  asm
    xor ax,ax
    mov al,[Mode]
    int 10h
  end;

procedure VGA_Put_Pixel(X,Y:Integer;Color:Byte);assembler;
  asm
    les di,double_buffer
    mov di,y
    shl di,6
    mov bx,di
    shl di,2
    add di,bx
    add di,x
    mov al,byte ptr color
    mov es:[di],al
  end;

procedure VGA_Set_Palette(Palette:VGA_Palette);
var Segment,Offs:Word;
begin
  Segment:=Seg(Palette);
  Offs:=Ofs(Palette);
  asm
    mov ah,10h
    mov al,12h
    mov bx,0
    mov cx,256
    mov dx,offs
    mov es,segment
    int 10h
  end;
end;

procedure VGA_Load_Palette(Filename:String;var P:VGA_Palette;SetItNow:Boolean);
var F:File;
  begin
    LOG_Write('VGA_LOAD_PALETTE : ');
    Assign(F,Filename);
    {$I-}
    ReSet(F,SizeOf(P));
    if IOResult<>0 then
      begin
        VGA_Set_Mode(VGA_Text_Mode);
        LOG_WriteLn('error');
        LOG_Close;
        VGA_Fatal_Error('VGA_LOAD_PALETTE : Can not find '+Filename);
      end;
    LOG_WriteLn('ok');
    {$I+}
    BlockRead(F,P,1);
    Close(F);
    if SetItNow then
    VGA_Set_Palette(P);
  end;

procedure VGA_Write_Palette(Filename:String;var P:VGA_Palette);
var
  F : File;
  R : Integer;
  begin
    Assign(F,Filename);
    {$I-}
    ReWrite(F,SizeOf(P));
    R := IOResult;
    if R <> 0 then
      begin
        VGA_Done;
        WriteLn('VGA_Write_Palette: I/O error:', R);
        Halt;
      end;
    BlockWrite(F,P,1);
    Close(F);
  end;

procedure Palette4;External;
{$L NEW4.OBJ}

procedure VGA_Init;
  begin
    LOG_Write('VGA_INIT : ');
    if MemAvail < SizeOf(VGA_Buffer) then
      begin
        LOG_WriteLn('error');
        LOG_Close;
        VGA_Fatal_Error('VGA_INIT : not enough memory to allocate double buffer');
      end;
    LOG_WriteLn('ok');
    New(Double_Buffer);
    FillChar(Double_Buffer^,320*200,0);
    VGA_Set_Mode(VGA_256_Color);
    VGA_Pal := @{New_VGA_Palette}Palette4;
    VGA_Set_Palette(VGA_Pal^);
  end;

procedure VGA_Done;
  begin
    VGA_Set_Mode(VGA_Text_Mode);
    if Double_Buffer <> nil then
    Dispose(Double_Buffer);
  end;

procedure VGA_Show_Double_Buffer;assembler;
  asm
    mov dx,03dah
    @NoRetrace:
    in al,dx
    and al,8
    jz @NoRetrace
    @Retrace:
    in al,dx
    and al,8
    jnz @Retrace
    push ds
    les di,Video_Buffer_Ptr
    lds si,Double_Buffer
    mov cx, 32000
    cld
    rep movsw
    pop ds
  end;

procedure VGA_Show_Double_Buffer_2;assembler;
  asm
    push ds
    les di,Video_Buffer_Ptr
    lds si,Double_Buffer
    mov cx, 32000 {320*200/2}
    cld

    rep movsw
    pop ds
  end;

procedure VGA_Bar(X1,Y1,X2,Y2:Integer;B:Byte);assembler;
label
  _l1;
asm
  push  ds
  push  es
  mov   ax,word(Double_Buffer+2)
  mov   es,ax
  mov   ax,y1
  mov   bx,320
  mul   bx
  mov   di,ax
  add   di,x1
  mov   ax,y1
  mov   dx,y2
  sub   dx,ax
  inc   dx

  mov   ax,x1
  mov   cx,x2
  sub   cx,ax { cx contains number of bytes across }
  inc   cx
  mov   al,b
  cld
_l1:
  push  di
  push  cx
  rep   stosb
  pop   cx
  pop   di
  add   di,320
  dec   dx
  jnz   _l1
  pop   es
  pop   ds
end;

procedure VGA_Blit_Char(XC, YC:Word; Ch:Char);
type
  TCharBuffer=array[0..7]of Byte;

const
  Bit_Mask:Byte=$80;
  Char_Width=7;
  Char_Height=7;

var
  Offset,X,Y:Word;
  Data:Byte;
  Rom_Char_Set:Array[0..255]of TCharBuffer absolute $F000:$FA6E;
  Work_Char:TCharBuffer;
  Count:Word;

begin
  Count:=0;
  Work_Char := Rom_Char_Set[Byte(Ch)];
  Offset := (YC shl 8) + (YC shl 6) + XC;

  For Y:=0 to Char_Height do
    begin
      Bit_Mask:=$80;
      For X:=0 to Char_Width do
        begin
          if (Work_Char[Count] and Bit_Mask <> 0) then Double_Buffer^[Offset+X]:=Global_Color;
          Bit_Mask := Bit_Mask shr 1;
        end;
      Inc(Count);
      Inc(Offset,320);
    end;
  end;

procedure VGA_Blit_String(SX,SY:Word;S:String);
var
  Index:Byte;
  begin
    For Index:=1 to Length(S) do
      begin
        VGA_Blit_Char(SX,SY,S[Index]);
        Inc(SX,8);
      end;
    end;

procedure VGA_Blit_Compact_String(SX,SY:Word;S:String);
var
  Index:Byte;
  Old  : Byte;
  begin
    For Index:=1 to Length(S) do
      begin
        if Index = 1 then
          begin
            Old := Global_Color;
            VGA_Set_Color(25);
            VGA_Blit_Char(SX,SY,S[Index]);
            VGA_Set_Color(Old);
            Inc(SX,7);
          end
        else
          begin
            VGA_Blit_Char(SX,SY,S[Index]);
            Inc(SX,7);
          end;
      end;
    end;

function VGA_Get_Pixel(X,Y:Word):Byte;
  begin
    VGA_Get_Pixel := Double_Buffer^[(Y shl 8) + (Y shl 6) + X];
  end;

procedure VGA_Set_Color(C:Byte);
  begin
    Global_Color:=C;
  end;

procedure VGA_HLine(X1,X2,Y1 : Word);
var Segment : Word;
begin
  Segment := Seg(Double_Buffer^);
 Asm
  mov si,320

  mov cx,x2
  sub cx,x1

  mov ax,y1
  mov bx,x1

  xchg ah,al
  add bx,ax
  shr ax,2
  add bx,ax
  mov ax,Segment
  mov es,ax
  mov di,bx

  mov di,bx
  inc cx
  mov al,Global_Color
  rep stosb
End;
end;

procedure VGA_VLine(Y1,Y2,X1 : Word);
var Segment:Word;
begin
 Segment := Seg(Double_Buffer^);
 Asm
  mov si,320
  mov ax,y1
  mov bx,y2
  mov cx,bx
  sub cx,ax
  jge @L31
  neg cx
  mov ax,bx
@L31:
  inc cx
  mov bx,x1

  xchg ah,al
  add bx,ax
  shr ax,2
  add bx,ax
  mov ax,Segment
  mov es,ax
  mov di,bx

  dec si
  mov al,Global_Color
@L32:
  stosb
  add di,si
  loop @L32
End;
end;

procedure VGA_Rectangle(X1,Y1,X2,Y2:Word);
  begin
    VGA_HLine(X1,X2,Y1);
    VGA_HLine(X1,X2,Y2);
    VGA_VLine(Y1,Y2,X1);
    VGA_VLine(Y1,Y2,X2);
  end;

Procedure VGA_Clear_Screen;assembler;
asm
  les di,Double_Buffer
  mov cx,320*100
  xor ax,ax
  rep stosw
end;

procedure VGA_Blit_Cool_Char(XC, YC:Word; Ch:Char; Color:Byte);
type
  TCharBuffer=array[0..7]of Byte;

const
  Bit_Mask:Byte=$80;
  Char_Width=7;
  Char_Height=7;

var
  Offset,X,Y:Word;
  Data:Byte;
  Rom_Char_Set:Array[0..255]of TCharBuffer absolute $F000:$FA6E;
  Work_Char:TCharBuffer;
  Count:Word;

begin
  Count:=0;
  Work_Char := Rom_Char_Set[Byte(Ch)];
  Offset := (YC shl 8) + (YC shl 6) + XC;

  For Y:=0 to Char_Height do
    begin
      Bit_Mask:=$80;
      For X:=0 to Char_Width do
        begin
          if (Work_Char[Count] and Bit_Mask <> 0) then Double_Buffer^[Offset+X]:=Color;
          Bit_Mask := Bit_Mask shr 1;
        end;
      Inc(Count);
      Inc(Offset,320);
      Inc(Color);
    end;
  end;

procedure VGA_Blit_Cool_String(SX,SY:Word;S:String;Color:Byte);
var
  Index:Byte;
  begin
    For Index:=1 to Length(S) do
      begin
        VGA_Blit_Cool_Char(SX,SY,S[Index],Color);
        Inc(SX,8);
      end;
    end;

procedure VGA_Direct_Put_Pixel(X,Y:Integer;Color:Byte);assembler;
  asm
    les di,video_buffer_ptr
    mov di,y
    shl di,6
    mov bx,di
    shl di,2
    add di,bx
    add di,x
    mov al,byte ptr color
    mov es:[di],al
  end;

procedure VGA_Wait_For_VSync;assembler;
  asm
    mov dx,03dah
    @NoRetrace:
    in al,dx
    and al,8
    jz @NoRetrace
    @Retrace:
    in al,dx
    and al,8
    jnz @Retrace
  end;

procedure VGA_Make_All_BlackWhite;

function Get_Shade(Offset:Word) : Byte;
var Res : Word;
  begin
    With VGA_Pal^[Double_Buffer^[Offset]] do
    Res := (Red + Green + Blue) div 3;
    if Res > 63 then Res := 63;
    Get_Shade := Res;
  end;

var
  I :  Word;
  Shade : Byte;
  begin
    For I := 0 to SizeOf(VGA_Buffer) do
      begin
        Shade := Get_Shade(I);
        if Shade > 25 then Shade := 25;
        Double_Buffer^[I] := Shade;
      end;
    end;

procedure VGA_Line(X1,Y1,X2,Y2:Integer);

function Sgn(A:Real):Integer;
  begin
    if A>0 then Sgn:=+1;
    if A<0 then Sgn:=-1;
    if A=0 then Sgn:=0;
  end;

var
U,S,V,D1X,D1Y,D2X,D2Y,M,N:Real;
I:Integer;

begin
  U:=X2-X1;
  V:=Y2-Y1;
  D1X:=Sgn(U);
  D1Y:=Sgn(V);
  D2X:=Sgn(U);
  D2Y:=0;
  M:=Abs(U);
  N:=Abs(V);
  if not (M>N) then
    begin
      D2X:=0;
      D2Y:=Sgn(V);
      M:=Abs(V);
      N:=Abs(U);
    end;
  S:=Int(M/2);
  For I:=0 to Round(M) do
     Begin
       VGA_Put_Pixel(X1,Y1,Global_Color);
       S:=S+N;
       If not (S<M) then
         begin
           S:=S-M;
           X1:=X1+Round(D1X);
           Y1:=Y1+Round(D1Y);
         end
       else
         begin
           X1:=X1+Round(D2X);
           Y1:=Y1+Round(D2Y);
         end;
       end;
     end;

procedure VGA_Blit_Char_2(XC, YC:Word; Ch:Char);
type
  TCharBuffer=array[0..7]of Byte;

const
  Bit_Mask:Byte=$80;
  Char_Width=7;
  Char_Height=7;

var
  Offset,X,Y:Word;
  Data:Byte;
  Rom_Char_Set:Array[0..255]of TCharBuffer absolute $F000:$FA6E;
  Work_Char:TCharBuffer;
  Count:Word;

begin
  Count:=0;
  Work_Char := Rom_Char_Set[Byte(Ch)];
  Offset := (YC shl 8) + (YC shl 6) + XC;

  For Y:=0 to Char_Height do
    begin
      Bit_Mask:=$80;
      For X:=0 to Char_Width do
        begin
          if (Work_Char[Count] and Bit_Mask <> 0) then
          Double_Buffer^[Offset+X]:=Global_Color;
          Bit_Mask := Bit_Mask shr 1;
        end;
      Inc(Count);
      Inc(Offset,320);
    end;
  end;

procedure VGA_Blit_String_2(SX,SY:Word;S:String);
var
  Index:Byte;
  begin
    For Index:=1 to Length(S) do
      begin
        VGA_Set_Color(51);
        VGA_Blit_Char_2(SX,SY,S[Index]);
        VGA_Set_Color(53);
        VGA_Blit_Char_2(SX+1,SY,S[Index]);
        Inc(SX,9);
      end;
    end;

procedure VGA_Blit_Char_D(XC, YC:Word; Ch:Char);
type
  TCharBuffer=array[0..7]of Byte;

const
  Bit_Mask:Byte=$80;
  Char_Width=7;
  Char_Height=7;

var
  Offset,X,Y:Word;
  Data:Byte;
  Rom_Char_Set:Array[0..255]of TCharBuffer absolute $F000:$FA6E;
  Work_Char:TCharBuffer;
  Count:Word;

begin
  Count:=0;
  Work_Char := Rom_Char_Set[Byte(Ch)];
  Offset := (YC shl 8) + (YC shl 6) + XC;

  For Y:=0 to Char_Height do
    begin
      Bit_Mask:=$80;
      For X:=0 to Char_Width do
        begin
          if (Work_Char[Count] and Bit_Mask <> 0) then Video_Buffer[Offset+X]:=Global_Color;
          Bit_Mask := Bit_Mask shr 1;
        end;
      Inc(Count);
      Inc(Offset,320);
    end;
  end;

procedure VGA_Blit_String_D(SX,SY:Word;S:String);
var
  Index:Byte;
  begin
    For Index:=1 to Length(S) do
      begin
        VGA_Blit_Char_D(SX,SY,S[Index]);
        Inc(SX,8);
      end;
    end;

procedure VGA_Make_BW;
var
  I     : Word;
  B     : Byte;
  Pixel : Byte;
  begin
    For I := 0 to SizeOf(VGA_Buffer)-1 do
      begin
        Pixel := Double_Buffer^[I];
        With VGA_Pal^[Pixel] do
        B := (Red + Green + Blue) div 3;
        if B > 30 then B := 30;
        Double_Buffer^[I] := B;
      end;
  end;

procedure VGA_Blit_Int(X, Y : Word; N : LongInt);
var S : String[32];
  begin
    Str(N, S);
    VGA_Blit_String(X, Y, S);
  end;

function Graph_ReadLn(S0 : String; X,Y:Word) : String;
var
  S    : String;
  Code : Byte;
  Ch   : Char;
  Time : Word;

  begin
    Ch := #0;
    Time := 0;
    S := S0;
    VGA_Bar(X,Y,X+200,Y+11,20);
    VGA_Set_Color(25);
    VGA_Rectangle(X-1,Y-1,X+201,Y+12);
    VGA_Set_Color(25);
    Repeat
      VGA_Blit_String(X + 2, Y + 2, S);
      if Time < 25 then
      VGA_Blit_Char(X+Length(S)*8+2, Y+2, '_');
      asm
        push ds
        les di,Video_Buffer_Ptr
        lds si,Double_Buffer
        mov cx, 32000 {320*200/2}
        cld
        rep movsw
        pop ds
      end;
      VGA_Bar(X,Y,X+200,Y+11,103);
      if KeyPressed then
        begin
          Ch := ReadKey;
          Ch := UpCase(Ch);
          if (Ch in [#32..#128]) and (Length(S) < 10) then S := S + Ch else
          Case Ch of
            #8 : Delete(S, Length(S), 1);
          end;
        end;
      if Time < 50 then Inc(Time) else Time := 0;
    Until Ch in [#13, #27];
    if Ch = #13 then Graph_ReadLn := S
    else Graph_ReadLn := '';
  end;

function FileFound(S:String) : ByteBool;
var R : SearchRec;
  begin
    FindFirst(S, AnyFile, R);
    FileFound := DosError = 0;
  end;

begin
  Double_Buffer := nil;
end.